;*******************************************************************
; Double Precision Multiplication
;
; PassArg2 : PassArg1 * PassArg4 : PassArg3 -> PassArg8:PassArg7:PassArg6:PassArg5
;
;signed multiply of PassArg2:PassArg1 with PassArg4:PassArg3 leaving
;result in PassArg8:PassArg7:PassArg6:PassArg5

; Standard shift and add.
; Execution time: 215 to 295 clock cycles.
; Code space: 22 locations
;
; Cleaned up and corrected version from Microchip Ap note by BF.
; Note: Ap note has errors! Additional mods by Scott Dattalo.
;
;*******************************************************************

Multiply16x16
	local m1, m2
	clrf PassArg8
	clrf PassArg7
	clrf PassArg6
	clrf PassArg5
	bsf PassArg6, 7
m1:
	rrf PassArg2, f
	rrf PassArg1, f
	skpc
	goto m2
	movf PassArg3, w
	addwf PassArg7, f
	movf PassArg4, w
	skpnc
	incfsz PassArg4, w
	addwf PassArg8, f
m2:
	rrf PassArg8, f
	rrf PassArg7, f
	rrf PassArg6, f
	rrf PassArg5, f
	skpc
	goto m1
	return