;On Call:
;PassArg1 = 16Bit LOW Byte
;PassArg2 = 16Bit HIGH Byte
;PassArg7:PassArg6:PassArg5:PassArg4:PassArg3 The 5 digits

b16_d5
				swapf PassArg1,w ; partial ones sum in low byte
				addwf PassArg1,w ;
				andlw 0x0f ;
				skpndc ;
				addlw 0x16 ;
				skpndc ;
				addlw 0x06 ;
				addlw 0x06 ;
				skpdc ;
				addlw -0x06 ; wmax=3:0
				;
				btfsc PassArg1,4 ; complete ones sum in low byte
				addlw 0x15+0x06
				skpdc
				addlw -0x06 ; wmax=4:5
				movwf PassArg3 ; save sum in PassArg3
				;
				; 8+ 4+ 2+ 1+ 8+ 4+ 2+ 1+
				; 20
				; 100 60 30 15+
				; ----------------------------------------------------
				; 128 64 32 16 8 4 2 1
				;
				swapf PassArg2,w ; partial ones sum in high byte
				addwf PassArg2,w ;
				andlw 0x0f ;
				skpndc ;
				addlw 0x16 ;
				skpndc ;
				addlw 0x06 ;
				addlw 0x06 ;
				skpdc ;
				addlw -0x06 ; wmax=3:0
				;
				btfsc PassArg2,0 ; complete ones sum in high byte
				addlw 0x05+0x06
				skpdc
				addlw -0x06 ; wmax=3:5
				;
				btfsc PassArg2,4
				addlw 0x15+0x06
				skpdc
				addlw -0x06 ; wmax=5:0
				;
				addlw 0x06 ; include previous sum
				addwf PassArg3,w
				skpdc
				addlw -0x06 ; wmax=9:5, ones sum ended
				;
				movwf PassArg3
				movwf PassArg4
				swapf PassArg4,f
				movlw 0x0f
				andwf PassArg3,f ; save total ones sum in PassArg3
				andwf PassArg4,f ; save partial tens sum in PassArg4
				;
				; 8+ 4+ 2+ 1+ 8+ 4+ 2+ 1+
				; 5+
				; 60 80 90 10+ 5+
				; 700 300 100 80 40 20 10 50
				; 32000 16000 8000 4000 2000 1000 500 200
				; ------------------------------------------------------
				; 32768 16384 8192 4096 2048 1024 512 256
				;
				; complete tens sum in low and high byte
				rrf PassArg2,w ; rotate right high byte once
				andlw 0x0f ; clear high nibble
				addlw 0x06 ; adjust bcd
				skpdc
				addlw -0x06 ; wmax=1:5
				;
				addlw 0x06 ; include previous sum
				addwf PassArg4,w
				skpdc
				addlw -0x06 ; wmax=2:4
				;
				btfsc PassArg1,5
				addlw 0x03+0x06
				skpdc
				addlw -0x06 ; wmax=2:7
				;
				btfsc PassArg1,6
				addlw 0x06+0x06
				skpdc
				addlw -0x06 ; wmax=3:3
				;
				btfsc PassArg1,7
				addlw 0x12+0x06
				skpdc
				addlw -0x06 ; wmax=4:5
				;
				btfsc PassArg2,0
				addlw 0x25+0x06
				skpdc
				addlw -0x06 ; wmax=7:0
				;
				btfsc PassArg2,5
				addlw 0x09+0x06
				skpdc
				addlw -0x06 ; wmax=7:9
				;
				btfsc PassArg2,6
				addlw 0x08+0x06
				skpdc
				addlw -0x06 ; wmax=8:7
				;
				btfsc PassArg2,7
				addlw 0x06+0x06
				skpdc
				addlw -0x06 ; wmax=9:3, tens sum ended
				;
				movwf PassArg4 ; save total tens sum in PassArg4
				swapf PassArg4,w
				andlw 0x0f ; load partial hundreds sum in w
				;
				; 8+ 4+ 2+ 1+ 8+ 4+ 2+ 1+
				; 20+ 5+
				; 100+ 60+ 30+ 10+
				; ----------------------------------------------------
				; 128 64 32 16 8 4 2 1
				;
				; 8+ 4+ 2+ 1+ 8+ 4+ 2+ 1+
				; 5+
				; 60+ 80+ 90+ 10+ 5+
				; 700 300 100 80+ 40+ 20+ 10+ 50+
				; 32000 16000 8000 4000 2000 1000 500 200+
				; ------------------------------------------------------
				; 32768 16384 8192 4096 2048 1024 512 256
				;
				; complete hundreds sum in high byte
				btfsc PassArg2,1
				addlw 0x05+0x06
				skpdc
				addlw -0x06 ; wmax=1:4
				;
				btfsc PassArg2,5
				addlw 0x01+0x06
				skpdc
				addlw -0x06 ; wmax=1:5
				;
				btfsc PassArg2,6
				addlw 0x03+0x06
				skpdc
				addlw -0x06 ; wmax=1:8
				;
				btfsc PassArg2,7
				addlw 0x07+0x06
				skpdc
				addlw -0x06 ; wmax=2:5, hundreds sum ended
				;
				movwf PassArg5 ; save total hundreds sum in PassArg5
				swapf PassArg5,w
				movwf PassArg6 ; save partial thousands sum in PassArg6
				movlw 0x0f ; clear high nibble
				andwf PassArg4,f ;
				andwf PassArg5,f ;
				andwf PassArg6,f ;
				;
				; 8+ 4+ 2+ 1+ 8+ 4+ 2+ 1+
				; 5+
				; 60+ 80+ 90+ 10+ 5+
				; 700+ 300+ 100+ 80+ 40+ 20+ 10+ 50+
				; 32000 16000 8000 4000 2000 1000 500+ 200+
				; ------------------------------------------------------
				; 32768 16384 8192 4096 2048 1024 512 256
				;
				; complete thousands sum in low and high byte
				rrf PassArg2,w ; rotate right high byte twice
				movwf PassArg7 ;
				rrf PassArg7,w ;
				andlw 0x0f ; clear high nibble
				addlw 0x06 ; adjust bcd
				skpdc ;
				addlw -0x06 ; wmax=1:5
				;
				addlw 0x06 ; include previous sum
				addwf PassArg6,w
				skpdc
				addlw -0x06 ; wmax=1:7
				;
				btfsc PassArg2,6
				addlw 0x16+0x06
				skpdc
				addlw -0x06 ; wmax=3:3
				;
				btfsc PassArg2,7
				addlw 0x32+0x06
				skpdc
				addlw -0x06 ; wmax=6:5, thousands sum ended
				;
				movwf PassArg6 ; save total thousands sum in PassArg6
				movwf PassArg7 ;
				swapf PassArg7,f ; save ten-thousands sum in PassArg7
				movlw 0x0f ; clear high nibble
				andwf PassArg6,f ;
				andwf PassArg7,f ;
				return