				;Check A/D conversion
				movlb 0x01
				btfsc adcon0,ADGO				; A/D has finish?
				goto Cont2						; IF NO then just continue

				btfsc ADCON0,2					;Check which channel was reading
				goto AD_Channel_1				;
				;///////////////////////////////////////////////////
				;// A/D read cycle
				;// It was reading channel 0 - BLACK potentiometer - FAN SPEED
				;// The system will prepare to read channel 
				;///////////////////////////////////////////////////
				movlw b'00000101'				;Prepare channel 1 for read
				movwf adcon0
				movf ADRESH,w					;Get results
				movlb 0x00
				movwf Pot1_Value

				movwf FanSetSpeed
				bcf carry
				rrf FanSetSpeed,w
				addlw d'128'
				movwf FanSetSpeed
				
				movf FanSetSpeed,w
				movlb 0x06
				movwf CCPR3L
				movlb 0x00

				call ShowDisplayDigits
				movlb 0x01
				bsf adcon0,ADGO				;Start A/D
				movlb 0x00
				goto Cont2
AD_Channel_1
				;///////////////////////////////////////////////////
				;// A/D read cycle
				;// It was reading channel 1 - BLUE potentiometer - SP temperature
				;// The system will prepare to read channel 0
				;///////////////////////////////////////////////////
				movlw b'00000001'				;Prepare channel 0 for read
				movwf adcon0
				movf ADRESH,w					;Get results
				movlb 0x00
			
				;Scale input
				movwf passarg1
				movlw d'90'
				movwf Pot0_Value
				movlw d'2'
				goto $+3
AD_Channel_1_DivBy3
				incf Pot0_Value,f
				movlw d'3'
				subwf passarg1,f
				btfsc zero
				goto AD_Channel_1_ScaleEnds
				btfss carry
				goto AD_Channel_1_ScaleEnds
				goto AD_Channel_1_DivBy3

AD_Channel_1_ScaleEnds
				movf Pot0_Value,w
				movwf Temperature_SP
				movwf passarg1
				call Bin8ToDecimal
				movf PassArg4,w
				movwf Digit4_Number
				movf PassArg5,w
				movwf Digit5_Number
				movf PassArg6,w
				movwf Digit6_Number
				call ShowDisplayDigits
				movlb 0x01
				bsf adcon0,ADGO				;Start A/D
				movlb 0x00
