;/////////////////////////////////////////////////////////////////
; mSec_DELAY_GENERATOR @ 8MHz Oscillator
; REQUIRES: NONE
; Description: Delay basis 
;
; BYTE 1 (FIRST OUT) Bits <7-0>: Data bit 0 - Data bit 7
; BYTE 2 (2nd OUT) <7-3>Unused <2>=RS <1>R/W <0> E
;/////////////////////////////////////////////////////////////////
; ---ON CALL---
; W: num of mSecconds to delay
;
; ---ON RETURN---
; NONE
;
; ---INTENALLY USED---
; WaitCounter
; WaitCounter2
; ------- copy paste code ---------
; WaitCounter     equ 0x20
; WaitCounter2    equ 0x21
; ---------------------------------
;
; ---DEFINITIONS---
; NONE
;
;/////////////////////////////////////////////////////////////////


StartDelayCount movwf WaitCounter2		;1    

BackWaitLoop2   movlw d'249'			;1
                call WaitWx4Cycles		;2+996
                movlw d'249'			;1
                call WaitWx4Cycles		;2+996
                movlw d'249'			;1
                call WaitWx4Cycles		;2+996
                movlw d'249'			;1
                call WaitWx4Cycles		;2+996
                movlw d'200'			;1
                call WaitWx4Cycles		;2+992
                movlw d'120'			;1
                call WaitWx4Cycles		;2+992
				nop
				nop
                decf WaitCounter2,f		;1
                btfss zero				;1
                goto BackWaitLoop2		;2
                return					;2

WaitWx4Cycles   movwf WaitCounter
BackWaitLoop    decfsz WaitCounter,f
                goto BackWaitLoop
                return

Wait1mSec       movlw d'1'
                goto StartDelayCount
Wait2mSec       movlw d'2'
                goto StartDelayCount
Wait4mSec       movlw d'4'
                goto StartDelayCount
Wait10mSec      movlw d'10'
                goto StartDelayCount
Wait50mSec      movlw d'50'
                goto StartDelayCount
Wait100mSec      movlw d'100'
                goto StartDelayCount
Wait250mSec     movlw d'250'
                goto StartDelayCount


Wait1Sec		call Wait250mSec
				call Wait250mSec
				call Wait250mSec
				goto Wait250mSec